#include "types.h"
#include "warning.h"
#include "pin.h"
#include "pixmap.h"
#include "widget.h"
#include "timer.h"
#include "animwid.h"

void animuj (kq_anim *anim)
{
  anim->faze++;
  if(anim->faze >= anim->pocet) anim->faze = 0;
  prebarviwidget(anim->widget, anim->pix[anim->faze]);

  if(!aktutimer){
    warning("animuj: chybi aktutimer");
    return;
  }

  aktutimer->zbyva = anim->casy[anim->faze];
  if(aktutimer->opakovani == 0) anim->timer = NULL;
}

void startanimwid (kq_anim *anim, int x, int y, float z, float priorita,
		   int opakovani, char lokalni, char pauhide)
{
  anim->faze = 0;
  anim->widget = vytvorwidget (x, y, z, anim->pix[0], lokalni, pauhide);
  if(pauhide < 0) pauhide = 0;
  anim->timer = vytvortimer(&animuj, pinpointer(anim), anim->casy[0], priorita,
			    opakovani, lokalni, pauhide);
}



























