\subsec Deifrovn inputu

Tento modul e pevod stringu, kter hr nape, na uritou funkci
s~uritmi parametry. Tato urit funkce pak provede vznam napsan
vty. Tuto konverzi provede funkce \dg [void] provedstr()

\ins c provedstr

Nejprve je string pemnn na "kq_list" ukazatel na strukturu
\dg [struct] slovo funkc "rozeberstr".

\ins h slovo

Poloka poet udv, kolikrt je slovo uloeno v~hashi, tedy kolik
rznch nzv me mt. Tento daj je vyuit pi uvolovn slov
z~pamti.

Dle je zde poloka "makro", kter, pokud je true, znamen, e slovo
je makrem. Takov slovo je expandovno na seznam jinch slov, kter
makrem nejsou.

S~tm souvis poloka "u". Kdy je slovo makrem, tak je vyuita jej
podpoloka "nahradit", kter obsahuje list slov, na kter m bt slovo
expandovno. V~opanm ppad je vyuita podpoloka vty.

V~poloce "ulozeno" je odkaz na "kq_word", kde jsou daje
o~slov pro funkci, kter se nakonec spust. Tato poloka tak me
bt "NULL". V~takovm ppad by se slovo do tto funkce nemlo dostat.
V~poloce "kateg" je pole kategori, pod kter toto slovo spad, co
uruje, do kterch vt se slovo hod a do kterch ne.

Funkce \dg [kq_list *]rozeberstr() dostane string a~funkci, kterou m
zavolat, kdy njak slovo nepochop. Nejprve si
string zduplikuje a aplikuje na nj funkci "upravstring", m
zajist, e v~textu nebudou pebyten mezery, velk psmena a dal
podivn znaky. Pak si pete slovo a po prvn mezeru a vyhled ho
v~hashi pod dvma typy. Zjist jednak, zda jde o~slovo (typ "WORD")
a~tak, zda jde o~st slova (typ "WORDPART"). Pokud zjist, e to je
st slova, zkus do tohoto slova pidat dal sek textu po dal
mezeru. Jakmile to st slova nen nebo naraz na konec stringu,
sebere ze stringu posledn nalezen slovo a do listu pid pointer
z~nlezu tohoto slova v~hashi.

\ins c rozeberstr

Na tento list je pak aplikovna funkce \dg [void] expandvetu(), kter vechna
slova, kter jsou makrem, nahrad skupinou slov v~poloce "u.nahradit".

\ins c expandvetu

Nakonec je list peveden na pole, na kter se zavol funkce
\dg [void] provedvetu().

Tato funkce nejprve zkontroluje, zda se ve vt nenachz slovo mimo
kontext. To je takov slovo, ve kterm "ulozeno->kontext <= 0". Potom
hled vtu, kter je kompatibiln s~polem, kter dostala.

Vtu zastupuje ukazatel na \dg [struct] veta, tato struktura
vypad nsledovn:

\ins h veta

Aby bylo mono mezi vtami vyhledvat, jsou azeny do seznam, kde jsou
propojeny pes poloky "next". Dle je zde pole "cleny", jeho dlku
udv poloka "pocetclenu" a struktura \dg [struct] vetnyclen
vypad nsledovn:

\ins h vetnyclen

Pokud "jekat == 0", mus bt na danm mst slovo stejn jako
v~poloce "u.presneslovo". Pokud "jekat != 0", mus bt mezi polem
"u.kateg" a polem kategori ve slov na onom mst neprzdn
prnik. Pole "u.kateg" je ukoneno nulou.

Abych pi vyhledvn sprvn vty nemusel prohledat vechny, mm
seznamy vt roztdn podle prvnho vtnho lenu urenho pesnm
slovem. Vdy pi vytvoen vty je tedy vyhledn prvn takov vtn
len a pak je vta pidna do seznamu v~poloce "u.vety" toho
slova. Pokud nem vta dn vtn len, kde "jekat != 0", je pidna do
globlnho seznamu vt \dg [struct veta *]jenkat.

\ifirst {input.c}{jenkat}{}{++}

Pi hledn vty jsou nejprve prohledny vty prvnho slova, pak vty
druhho slova, ..., a vty poslednho slova a nakonec je prohledn
seznam "jenkat".

Pot, co je vta nalezena, je teba si pipravit pole
parametr. Vytvo se pole pointer na "kq_word" tak velik, jak udv
poloka pocetparam dan vty a cel se pronuluje. Pak se prochz
vtn leny a kad vtn len, jeho "mistoparam" je nezporn, udv
index do toho pole, kam se m dan vtn len nahrt. Konkrtn se tam
zkopruje poloka "ulozeno" pslunho slova. Nakonec je sputna
"funkce" nalezen vty s~dvma parametry. Prvn je dlka pole neboli
"pocetparam" a druh je to pole.

\ins c provedvetu

\subsec Syntaxe jazyka inputu

Ve zmnn datov struktury se mus njakm zpsobem naplnit. st
informac je nateno ze souboru, take je mon zmnou natanho
souboru zmnit jazyk, kterm budeme s~pankem hovoit. V~souboru jsou
ignorovny znaky, kter nejsou v~sekci slov ani vt. Tyto sekce se
mohou opakovat. Sekce slov zan stringem "words{" na zatku dku a
kon zavrac svorkatou zvorkou. Sekce vt zan stringem
"sentences{" na zatku dku a kon tak zavrac zvorkou.

Pi ten souboru me program narazit na backshlash nebo
procento. Procento zru veker text (vetn backshlash a zavracch
zvorek) a po konec dku, ale ponech enter. Backshlash se pouv
pro zamaskovn enteru, ili {\langleactive "\ <enter>"} se promni
v~mezeru. Dvojice "\\" se promn v~jeden backshlash. Pokud je za
backshlashem procento, tak se nejprve aplikuje procento, kter po sob
zanech enter, ten je pak backshlashem promnn v~mezeru. Ve vech ostatnch
ppadech backshlash jen zmiz sm a tak mezery, co jsou za nm.

Kad slovo i kad vta odpovd jednomu neprzdnmu dku v~sekci
slov nebo vt. Nejjednodu deklarace vty je pmo napsan
vta. Vty maj ovem takov omezen, e nemohou mt mce ne 26
len, tedy slov. Kad slovo z~tto vty mus bt dve deklarovno v~sti
slov. Vce mezer se promni v~jednu mezeru a mezery na krajch dku
jsou ignorovny. Za mezeru je povaovn i jin znak, kter nen
psmeno a nen jinak zpracovn. Nejjednodu pklad takovho souboru
tedy vypad takto:

\begtt
words{
  jdi
}
sentences{
  jdi
}
\endtt

V~restartujc funkci by pak mla bt zavolna funkce "add_sent"
s~parametrem pointer na funkci, kter se m pi zavoln t vty
provst. Pokud bude v~souboru vce vt, ml by bt ve zdrojku stejn
poet voln  funkce "add_sent" a jednotliv funkce budou pak
piazeny dkm vt {\it ve stejnm poad}. Tm propojme texty
v~souboru s~konkrtnmi funkcemi ve zdrojovm kdu programu.

Na dku v~sekci vt me bt stednk, kter jakoby zalo nov dek
vty, ale pro funkci "add_sent" se tv stle jako jeden dek, tedy
vem vtm oddlenm stednkem je piazena stejn funkce. Podobn se
daj stednkem oddlovat slova. Jak je rozdl mezi slovy oddlenmi
stednkem a oddlenmi enterem vysvtlm pozdji. Zatm rozdl nen
dn.

\begtt
words{
  jdi; zastav; se; stj;
}
sentences{
  jdi
  zastav se; stj
}
\endtt

Ve zdrojku by pak mlo bt nco jako:

\begtt
add_sent(&chod); // propoji se s prvnim radkem v "sentences"
add_sent(&stuj); // propoji se s druhym radkem v "sentences"
\endtt

Slova jednoho vznamu mohou mt vce zpsob, jak je napsat
(synonyma). Synonyma se vytvo tak, e se na dku (stednk tak
oddluje dky) slova oddl rkami. Tm se prvn slovo stane
pvodnm slovem a ostatn v~tomto dku synonymy, kter se v~nj
promn. rky se daj uzavt do kulatch zvorek. Tm se okol
zvorek zkopruje a ze vnitku se vdy vybere jedna monost. Napklad

\begtt
velk (pn, lovk, mu)
\endtt

expanduje na

\begtt
velk pn, velk lovk, velk mu
\endtt

Mezery jsou odstraovny a po expanzi, take nen teba eit
napklad dv mezery mezi "velk" a "lovk". Pokud ovem napete

\begtt
papr(ek, eek)
\endtt

neexpanduje to na "paprek" a "papreek", ale na

\begtt
paprek, papr eek
\endtt

Msto kulatch zvorek se tak daj pout zvorky hranat, kter
oznauj nepovin text. Maj tedy stejn vznam jako kdy by na
zatku kulatch zvorek byla rka. Zvorky mohou bt i vnoen.

Dal pklad: dky

\begtt
[toho] (pna, lovka, mue)
shrek, [[hrkov, pern] zelen] [zl]obr
\endtt

expanduj na

\begtt
pna, lovka, mue, toho pna, toho lovka, toho mue
shrek, obr, zlobr, zelen obr, zelen zlobr, hrkov zelen obr,    \
   hrkov zelen zlobr, pern zelen obr, pern zelen zlobr
\endtt

Po expanzi se mohou objevit przdn slova, kter neobsahuj dn
psmeno. Takov jsou jednodue ignorovna. Nen vak radno, aby po
expanzi zstal cel dek przdn.

Kdy je na dku slova rovntko, tak se deklarovan slovo stane
makroslovem, kter se nahrad slovy, co jsou za rovntkem. Tato slova
u mus bt deklarovan a pokud zde jsou makroslova, jsou
expandovna. Neme se tedy stt, aby bylo makroslovo uvnit
makroslova.

Je dobr definovat vatu (tj. vplkov slova bez vznamu) jako 
makroslovo, kter expanduje na nic. Dle
jsem zjistil, e se makroslovo hod pro slovo "prozkoumej", kter
expanduje na dv slova: "koukni" a "na".

Vrtme se zpt k~deklaraci vty. Pokud je na dku s~vtou rka, za
n jsou napsny varianty, jak mohou bt uspodny slova tto vty
pomoc psmenek. Prvnmu slovu je piazeno psmeno "a", druhmu
psmeno "b", tetmu "c", ... Jsou-li ve vt makroslova, je psmeno
piazen celmu makroslovu a expanze probhne a pozdji. Jednotliv
uspodn jsou oddlena rkami a jsou v~nich ignorovny mezery. Jin
znaky by se tam nemly vyskytovat. Kdy u jsou ve vt takovto
poad, nen platn pvodn poad. Nemus bt pouita vechna
psmenka a nkter se mohou opakovat.

Z~toho plyne omezen, e vta neme mt vc ne 26 len. Toto
omezen plat i kdy leny nejsou vyjdeny psmeny.

Pklad:

\begtt
words{
  ukoni; program; v klidu
}
\sentences{
  program v klidu ukoni, bca, cba, acb, ca
}
\endtt

Funguje stejn jako kdyby v~sekci vt bylo napsno:

\begtt
  v klidu ukoni program; ukoni v klidu program;\
     program ukoni v klidu; ukoni program
\endtt

Slovm je mon pidlit kategorie tak, e se ped slovo nape
seznam kategori oddlench rkami do piatch zvorek. Kad
kategorie je urena njakm stringem. Velikost psmen zde ovem
nehraje roli, znak, kter nen psmenem, je povaovn za mezeru a poet
mezer u~sebe nehraje roli, tedy je na nzev kategori aplikovn
"upravstring". Kategorie napsan na zatku jsou stejn
pro vechna slova na onom dku. Stednk se zde stle chov jako
oddlova dku, ovem nen mon kategorie jakkoli zaplst do
expanze.

Ve vtch je pak mono pst stejnm zpsobem msto vtnho lenu
seznam kategori.

Pklad:

\begtt
words{
  otevi; seber; dej; na; prozkoumej
  <predm> sluchtko
  <otv, predm> truhlu
  <otv, misto> poklop
  <predm, misto> desku
}
sentences{
  prozkoumej <misto, predm>
  otevi <otv>
  seber <predm>
  dej <predm> na <misto>
}
\endtt

Pak program uzn nsledujc vty:
\begtt
prozkoumej sluchtko    otevi poklop              dej truhlu na poklop
prozkoumej truhlu       seber sluchtko            dej desku na poklop
prozkoumej poklop       seber truhlu               dej sluchtko na desku
prozkoumej desku        seber desku                dej truhlu na desku
otevi truhlu           dej sluchtko na poklop    dej desku na desku
\endtt

piat zvorky vak maj v~tomto okamiku jet jednu
vlastnost. Krom urovn kategori toti zad uloen tohoto
slova. To znamen, e ve stejnm poad, v~jakm jsou v~souboru
takovto slova, by mlo bt ve zdrojku pouita funkce
"add_word". Tato funkce vrt ukazatel na "kq_word", piem dostane
kontext, kter se tam dosad. Ve zdrojku by tedy mlo bt nco jako:

\begtt
kq_word *sluchatko, truhla, poklop, deska;

sluchatko = add_word(0);
truhla = add_word(0);
poklop = add_word(0);
deska = add_word(0);

add_sent(&chod);
add_sent(&stuj);
\endtt

Tato struktura \dg kq_word vypad nsledovn:

\ins h kq_word

Podstatn zde jsou poloky "kontext", "informace" a "info2".
Do poloky informace je mon si uloit libovoln daj
o~slov. Pi vytvoen je zde "pinnull". Poloka "typ" dv dal
monosti mt o~slov uritou pedstavu. Existuj zatm ti hodnoty,
kter jsou do tto poloky dosazovny:

\ins h typslova

\dg STDWORD je zde dosazen automaticky pi vytvoen slova. \dg
LANGWORD znamen, e se jedn o~slovo, kter pepn do jinho jazyka,
napklad slovo "english" pepne hru do anglitiny. \dg OBJWORD
znamen, e je to slovo psluejc uritmu pedmtu ("kq_predmet").

Poloku "typ" ani "informace" nen vhodn mnit v~prbhu hry, protoe
nejsou ukldny. Poloka "kontext" oproti tomu ukldna je. Krom
toho, e se v~tto poloce d uchovvat informace, slou jet
k~jednomu elu. Toti ono slovo se d pout jen v~ppad, kdy
"kontext > 0". V~opanm ppad program spust funkci "popup_warning"
s~parametry {\tt \char`\"_bad context\char`\"} a polokou "nazev"
pslunho slova.

Do poloky "nazev" je nahrn prvn string, pod kterm program slovo ulo.
To je takov, kde je ve vech seznamech oddlench rkami vybrna
prvn poloka a hranat zvorky jsou ignorovny.

Poloka "next" spolu s~promnnmi "prvulslovo"
a~"aktulslovo" ad tato slova do fronty. Poloky "Cislo"
a "loaded_kontext" jsou vyuvny moduly \cite save a load[m:save].

Nyn se dostvm k~uitenosti stednku v~sekci slov. Vem slovm
oddlenm stednkem na jednom dku se toti piad stejn slovo do
poloky "ulozeno". To, zda se slova na danm dku vbec ulo i
nikoliv rozhoduje jen totln zatek dku. Pokud tedy nechcete, aby
slovo bylo uloeno a pitom chcete, aby mlo piazen kategorie, je
mon napsat:

\begtt
words{
  otevi; seber; dej; na; prozkoumej
  ;<predm> sluchtko
  ;<otv, predm> truhlu
  ;<otv, misto> poklop
  ;<predm, misto> desku
}
\endtt

Pokud je douc, aby slovo bylo uloeno, a pitom nemlo dn
kategorie, je mon ped nj napsat jen przdn piat zvorky.

Stejn jako v~sekci slov maj piat zvorky jako vedlej efekt
uloen danho slova, maj v~sekci vt podobn vedlej efekt. Toti
leny uren piatmi zvorkami jsou pedny funkci dan
vty. Konkrtn je vytvoeno pole, kter m tolik prvk, kolik m vta
pedvanch len. Do tohoto pole se pak leny popoad
ukldaj. Nakonec jsou funkci pedny dva parametry, prvn je dlka
pole a druh je pole samotn.

V~ppad, e jsou za vtou napsna poad podle potench psmenek
abecedy, je poad v~poli parametr stle stejn. Stejn tak pole
parametr nemn velikost a v~ppad, e v~poad chyb nkter
parametr, je na jeho mst v~poli "NULL". Nedoporuuje se vak parametry
opakovat.

Me se stt, e je douc, aby bylo uloeno samotn slovo nebo
aby kategorie nebyly uloeny. To se d zadit dalmi typy
zvorek. Kulat zvorky oznauj sek, kter je ukldn. Hranat
zvorky maj stejn vznam jako piat, ale ukldny nejsou. Tedy
"([kateg])" m zde stejn vznam jako "<kateg>".

\subsec Interpretace natn inputu

Ped tm, ne je ten soubor, jsou volny funkce
\dg [kq_word *]add_word() a \dg [void] add_sent(). Tyto funkce si
zaad vtu nebo slovo do fronty. Tyto funkce jsou volny pi
kadm restartu, aby byl slovm opt nastaven poten kontext a
pedevm kvli sprvnmu propojen s~pedmty. To, zda tyto funkce
spoutm poprv nebo pi restartu poznm podle toho, zda je "win"
nulov. Slova jsou jednodue azena do fronty, kde prvnm prvkem je
\dg [kq_word *]prvulslovo a poslednm prvkem je \dg [kq_word *]aktulslovo. Do
promnn \dg [kq_word *]pocet_word ukldm poet slov v~tto front. 
Pi druhm prchodu u tuto frontu
jen prochzm promnnou "aktulslovo". 

\ifirst {input.c}{prvulslovo}{pocet_word}{++}

\insf add_word

Ukazatele na funkce vt adm do zsobnku "kq_list". Pi startu hry
je nakonec tento zsobnk zkonvertovn na pole funkc
\dg [void] finishws(). Dlka toho pole je v~promnn \dl [int]
dfv. Pi restartu nem funkce "add_sent" dn efekt.

\ifirst {input.c}{lsents}{dfv}{++}
\ifirst {input.c}{add_sent (}{\count=2 ^^B\cbrace}{++}

Pak spustm funkci \dg [void] nactiinput(). Tato funkce dostane nzev
jazyka a oteve pslun soubor. Dle nastav \dl [int] pps a \dl
[int] pfv na nulu. Tyto promnn jsou zkratkami od Poet Promnnch
Slov a Poet Funkc Vt. Promnnou "pps" jsou potna peten
uloen slova (tedy ta se skobatou zvorkou na zatku dku) a
promnnou "pfv" jsou potny peten vty. Na konci by se mlo
shodovat "pps" s~"pocet_word" a "pfv" s~"dfv" Pokud to neplat,
program vype warning.

Z~tohoto souboru te jednotliv
znaky. Pomoc loklnch promnnch "w" a "s" kontroluje shodu tench
znak se stringy \dg [char *]startword a \dg [char *]startsent.

\ifirst {input.c}{startword}{startsent}{++}

Jakmile shodu s~jednm ze string nalezne, spust funkci "ctiradky".

\insf nactiinput

Funkce \dl [void] ctiradky() nate do stringu vdy cel dek, piem
za oddlova dku povauje i stednk. Przdn dky (vce enter za
sebou) ignoruje. Jakoto parametr dostane soubor, kter m st a tak
funkci, kterou m na kad dek pustit. 
Tto ped ti parametry. Prvn je onen string, druh je daj, zda je
tento string na zatku dku (nen ped nm stednk), a tet je
daj, zda je tento string na konci dku (nen za nm stednk).
Funkce "ctiradky" se ukon v~okamiku, kdy naraz na zavrac
svorkatou zvorku.

\insf ctiradky

Pi ten dku vyuv funkci \dl [void] ctiznak() msto standardnho
"fgetc". Tato funkce zaizuje monost koment a ruen
backshlash. V~parametru je daj, zda m bt backshash aktivn.

\insf ctiznak

Pro pedn funkci "ctiradky" jsou zde pipraveny dv funkce. Prvn je
\dl [void] ulozslova().

\ifirst {input.c}{kq_word *tus}{^^B\cbrace}{++}

Nejdve se podvm na zatek a pokud tam je skobat zvorka natu
kategorie. Krom toho, v~ppad, e jsem na zatku dku, jet
ulom aktuln ukldan slovo do promnn \dl [kq_word *]tus. Pak
provedu expanzi a ulom slovo do hashe. Nakonec, pokud je na konci
rovntko, zmnm slovo na makroslovo.

Pro natn kategori pouiji funkci \dl [int *]nactikat(). Tato
funkce krom stringu dostane ukazatel na index tohoto stringu. Na
zatku je tento index nastaven na otevrac skobat zvorce a po
skonen je nastaven na znak tsn za zavrac zvorkou. Poslednm
parametrem je znak zavrac zvorky.

\insf nactikat

Kategorie je ze stringu pevedena na pirozen slo. Pole kategori
je zakoneno nulou. Stringm piazuji sla postupn od dvojky,
protoe slo 1 je rezervovno pro kategorii slov jazyk. Nejni
slo, ktermu jet nen piazena kategorie, je uloen v~promnn
\dl [int] poslkat.

\ifirst {input.c}{int poslkat}{}{++}

Pro konverzi ze stringu na slo je pouita funkce \dl [int] katnumber. Tato
funkce tak zalo novou kategorii, pokud dan string jet nebyl
pouit.

\insf katnumber

Pot, co funkce "ulozslova" zjist kategorie, spust expanzi. To e
funkce \dl [char **]seznamslov(). Tato funkce vrt pole
rozexpandovanch string. Prvn parametr tto funkce je string, kter
m bt expandovn a posledn (tvrt) je ukazatel na index do toho
stringu. Na zatku ukazuje na prvn znak t sti stringu, kter m
bt expandovna a na konci ukazuje na posledn znak (nula nebo
rovntko).

Druh a tet parametr jsou parametry vyuvan pi zarekurzen tto
funkce. Pokud tyto parametry nejsou nulou, ukazuj dal monosti,
kterm me expandovan string skonit. Funkce "seznamslov" zvldne
bez rekurze jen stringy, ve kterch se nevyskytuj zvorky. Funguje
tak, e v~promnn "s" si udruje index zatku dan verze slova a
promnnou "i" prochz pole dokud nenaraz na rku nebo na konec
(rovntko nebo nula). Kdy naraz na rku, ulo si slovo do seznamu
"l", posune si promnnou "s" za rku a pokrauje. Nakonec promn
seznam "l" na pole.

Pokud ovem naraz na otevrac zvorku, zahj rekurzi. Potebuje
toti rozexpandovat vnitek zvorky, a potom jet tu st za
zvorkou. Spust tedy dvakrt po sob sama sebe a zsk tak dv pole
string. Tato pole projde, propoj kad prvek s~kadm a na zatek
pipoj jet st ped zvorkami. Pi expanzi vnitku zvorek nebo
sti za zvorkami vak potebuji, aby se funkce ukonila dve, ne
kdy naraz na konec stringu. Pedvm tedy funkci parametry, kdy m
skonit. Do druhho parametru pedm uzavrac zvorku a do tetho
rku.

\insf seznamslov

Nakonec slova ukldm do hashe funkc \dg [void] wordtohash(). Krom
samotnho slova je toti teba uloit informaci o~stech slova.

\insf wordtohash

Druh funkce pro funkci "ctiradky" je \dl [void] ulozvetu(). Tato
funkce funguje tak, e si nejdve pete vtn leny do pole a pak
toto pole vyuv pi ten monch poad vty. Pokud dn poad
zapsan psmeny abecedy na dku nejsou, funkce si sama vyrob string
"abcd..." Pro kad string funkce nejprve spot poet vtnch len,
pak namallokuje pole pslun dlky a a v~druhm prchodu
kopruje vtn leny z~loklnho pole. Nakonec je vta pidlena ke
svmu prvnmu pesnmu slovu nebo do seznamu "jenkat".

\insf ulozvetu
