Zde se nataj z~XPM souboru obrzky pro zobrazen ve he. K~tomu
je zapoteb nast dal X-ov hlavikov soubory:

\ins h include

Zkladn funkce, kter nat XPM, je \dg [Pixmap] nactiXPM(). 
Tato funkce pete (spe si nech pest) soubor, 
kter zsk tak, e doleva pipe
"DATADIR" a "IMGDIR" a doprava pipe "IMGSUFFIX". Za normlnch
okolnost tedy tento soubor hled v~adresi s~obrzky a automaticky
k~nzvu pipoj pponu {\tt.xpm}. Z~tohoto souboru vytvo pixmapu
(obrzek na stran serveru), kterou vrt. Za parametrem "filename"
nsleduje parametr, kam se m uloit ximage (obrzek na stran
klienta), pak odkaz na pixmapu masky (ili kde je prhledno a kde ne)
a odkaz na ximage masky. Tyto parametry (kter jsou jen odkazem pro
uloen neho) mohou nabvat hodnoty "NULL", m dvte najevo, e se
o~dan nco nezajmte. Do pixmap jsou automaticky uloeny zvten
obrzky podle globln promnn \dg [int] ratio.

\ins h ratio

Pixmapy jsou tedy "ratio"-krt vt ne ximage. Zdrojov kd funkce
nactiXPM vypad takto:

\ins c nactiXPM

Pro vytvoen zvten pixmapy z~ximage jsem naprogramoval funkci \dg
[void] rescalePixmap(). Tato funkce m dva parametry: prvn je ten
ximage a druh odkaz na pixmapu. Pomr zvten si pete z~promnn
"ratio". Pokud v~pixmap nen "None", funkce pedpokld, e se tam
nalz pixmapa s~jinm pomrem zvten a tak ji uvoln z~pamti. Jsou
tyi monosti, jak tato funkce bude pracovat: 

\begitems
\item a) Pokud "ratio == 0", do pixmapy dosad "NULL".
\item b) Pokud "ratio > "\dg [int] IMAGRAT, prochz ximage po dcch a do nov
      	 pixmapy vykresluje po tverecch. Pokud je v~dku vce stejnch
	 pixel u~sebe, jsou tvereky vrmci ueten sovho penosu spojeny
	 do obdlnku.
\item c) Pokud "ratio == 1", jednodue pole ximage X-serveru.
\item d) V~ostatnch ppadech si vytvo pomocn ximage, do kterho to
      	 vyscaluje a pak tento pomocn ximage pole X-serveru.
\enditems

\ins c rescalePixmap

\subsec kq\_pixmap

Pro spojen vech potebnch pixmap a ximage jsem vytvoil datov typ
\dg kq_pixmap.

\ins h struktura

Poloka "scale" udv s~jakm "ratio" byly pixmapy naposledy
scalovny. Pi zmn rozlien toti pescaluji jenom viditeln
pixmapy a ostatnch se nedotknu. Poloka "lokalni" udv, podobn jako
u~\cite timer[m:timer] i \cite widget[m:widget], zda m bt pixmapa 
pi pechodu na jin polko
smazna ("lokalni=True") nebo zachovna ("lokalni=False").

Poloka "next" uruje dal pixmapu v~seznamu, kter zan pixmapou
\dg [kq_pixmap *]prvpix.

Pro pstup k~ce a vce pixmapy vyuvm nsledujc definice:

\dgn PIX_VYS \dgn PIX_SIR

\ins h define

Potom napklad ka pixmapy "pix" je "pix->PIX_SIR".

Tuto strukturu vytvom a zalenm do seznamu funkc \dg [kq_pixmap *]nactikqXPM().

\ins c nactikqXPM

Pokud ji ji nebudu pouvat, mohu ji uvolnit z~pamti a smazat ze
seznamu pomoc funkce \dg [void] freekqPixmap().

\ins c freekqPixmap

Pixmapy mm zaazen za sebou ze dvou dvod. Abych je mohl ukldat a
abych mohl smazat vechny lokln pixmapy. Toto mazn provd funkce
\dg [void] deletelpixmaps().

\ins c deletelpixmaps

Tak mohu smazat vechny pixmapy (pi natn pozice) funkc
\dg [void] deleteApixmaps()

\ins c deleteApixmaps

Pi uloen a naten pozice se smaou a znovu vytvo vechny
pixmapy. Tm pdem rovn pestanou fungovat pointery na
n. Samozejm je mon uvdomit modul \vizmod[save] o~tomto ukazateli
pomoc funkce "add_sl_var". Nkter pixmapy, kter jsou natny na
zatku programu a nebudou ji mazny, se daj tzv. zafixovat funkc
\dg [void] fix_pix(). Tato funkce me bt sputna pouze jednou, nkde
ped sputnm hlavnho cyklu a zafixuje vechny pixmapy, kter ji
byly nateny. Zafixovan pixmapy nen mon smazat a nebudou ukldny
do souboru. Jejich poet (zporn) funkce "fix_pix" ulo do promnn
\dg [int] pocet_fixpix a cel seznam pesune z~promnn "prvpix" do promnn
\dg [kq_pixmap *]fixed_pixmaps. Pi tom ulo do poloky "Cislo"
pslun zporn poad.

\ins c fixpix
