Tento modul e pepnn mezi polky (scnami). Aby vak bylo mon
mezi polky pepnat, je teba njak polko zaloit. Polko je
ukazatel na strukturu \dg kq_policko, kter vypad takto:

\inst kq_policko

Prvn poloka polka "locbarva" souvis s~\cite barvami[m:color]. Funkce
"pridejbarvu" obvykle pid barvu do zsobnku zanajcho barvou
"prvbarva". Pi hledn barvy pak je opt pouit zsobnk zanajc
barvou "prvbarva". Tento modul vak do barev vn jist
triky. Jakmile je zaloeno prvn polko, jsou nov barvy pidvny
pouze k~naposledy zaloenmu polku a je mon tyto barvy pout jen
v~ppad, e toto polko je prv aktuln.

Barvy, kter byly zaloeny ped prvnm polkem, je mon pouvat ve
vech polkch (jsou globln). Prvn globln barva (ta, kter byla
zaloena naposledy) je \dg [kq_color *]globbarva a ukazuj na n
posledn lokln barvy vech polek.

\ifirst {pol.h}{globbarva}{}{++}

Lokln barvy je mon pouvat jen v~takovch mapch, kter se
opravdu vyskytuj jen na jednom polku. Pokud zalote globln
submapu, kter obsahuje lokln barvu a pak pepnete na jin polko,
bude fungovat skoro ve bez problm, ale nebude pak mon uloit
takovou pozici (ppadn ji pak nast).

Poloka "jmpixmap" je string urujc soubor, ze kterho je peteno
pozad, a poloka "jmmapa" uruje soubor, ze kterho je petena
"bgmap".

Poloky "xa", "xb", "ya" a "yb" jsou pi zaktivnn polka pesunuty
do promnnch "map_xa", "map_xb", "map_ya", "map_yb".

Kad polko me sousedit se tymi jinmi polky, tedy s~jednm
nahoe, s~jednm dole, s~jednm vlevo a s~jednm v~pravo. Tato
sousedn polka jsou v~poloce "vedle". Napklad polko vpravo je
v~poloce "vedle[VPRAVO]". Pi vytvoen polka jsou vechna sousedn
polka nastavena na "NULL". Pro propojen dvourozmrnho pole
polek, mm pedpipravenou funkci \dg [void] spojpol(). Tato funkce
bude fungovat ovem jen v~ppad, e bylo pole deklarovno jako
dvourozmrn s~jasn danmi rozmry, tedy tv se jako
jednorozmrn. Funkce "spojpol" nejprve dostane pole, potom jeho
rozmry a nakonec daje, zda m pole torusoidn propojit horizontln
a vertikln.

\insf spojpol

Dal dv poloky jsou funkce "odchfunc" a "prichfunc". Tyto funkce se
spust pi pechodu postavy na jin polko, ale ne pi run zmn
polka.

Funkce "odchfunc" se spust jako prvn a dostane parametry:
polko, z~kterho bylo odejito, smr, kterm bylo odejito, ukazatel
na promnnou s~polkem, na kter bude pijito, ukazatel na X-ovou
souadnici, ukazatel na Y-ovou souadnici. Tato funkce tedy me
zmnit jak polko, tak souadnice, na kterch se postava
objev. V~ppad, e "smer" je "NAHORU", je vak Y-ov souadnice
rovna "-1" a pot se od dolnho okraje polka. Stejn tak se pot
od levho okraje polka X-ov souadnice v~ppad, e
"smer == VLEVO".

Funkce "prichfunc" dostane jednodue polko, z~kterho bylo odejito,
pak smr a nakonec polko, do kterho bylo pijito. Tato funkce je
sputna a v~okamiku, kdy je aktivn nov polko a je na nm ve,
co na nm m bt. Stejn jako tyto funkce jet existuj funkce
\dg [void *]pol_odchfunc() a \dg [void *]pol_prichfunc(), kter vak
nejsou polokou uvnit polka, ale globln promnnou, take jsou
spolen pro vechna polka. Tyto funkce jsou sputny okamit po
ukonen pislun funkce "odchfunc" i "prichfunc".

\ifirst {pol.c}{pol_prichfunc}{odchfunc}{++}

Poloky "pocetanim" a "pw" pidvaj do polka dal widgety,
poloka "psm" pidv do polka submapy a poloka "pp" pidv do
polka postavy. Podrobnji budou tyto poloky popsny, a budu
vysvtlovat "pol_widget", "pol_submap" a "pol_postava".

Dal poloka struktury "kq_policko" je list "ps". To je seznam
ukazatel na slova,
kter se na polku vyskytuj. Pi aktivaci polka je vem slovm
navena poloka "kontext" o~jedniku a pi deaktivaci polka je
tmto slovm opt "kontext" o~jedniku snen. Funkce
\dg [void] pridej_ps() pid slovo k~naposledy zaloenmu
polku. Ukazatele jsou pouity proto, e v~okamiku pouit tto
funkce jt slova nejsou zaloena.

\insf pridej_ps

Vechny ve zmnn poloky struktury "kq_policko" se polku
pidluj na zatku programu a dle s~nimi nen mon hbat, protoe
nejsou ukldny. Jedin, co je ukldno a souvis s~polky jsou
pedmty, tedy poloka "predmety". O~tch je vak cel modul
\vizmod[predmet].

Polka jsou azena do fronty zanajc promnnou
\dg [kq_policko *] prvpol a jejich poet je uloen v~promnn
\dg [int] pocet_pol. Polka jsou ve front propojena pomoc poloky
"next". Promnn \dg [kq_policko *]aktupol ukazuje pi tvoen polek
na posledn
prvek fronty polek, tedy na polko, ke ktermu jsou pidvny dal
daje. Pi he je "aktupol" polkem, kter je prv zobrazen.

\ifirst {pol.c}{aktupol}{pocet_pol}{++}

Funkce \dg [void] newpol() zalo nov polko. Po sputn tto
funkce je mon spoutet dal funkce, kter k~polku pidvaj
pixmapy, submapy, barvy, widgety, ...

\insf newpol

Funkce \dg [void] set_pol() nastav polko z~parametru jako "aktupol"
a zkopruje z~tohoto polka nkter daje. Tuto funkci je vhodn
spustit na zatku restartujc funkce pro nastaven startovnho
polka.

\insf set_pol

Funkce \dg [void] vykreslipol() aplikuje aktuln polko, tedy
zobraz a nate ve potebn.

\insf vykreslipol

Funkce \dg [void] prvnipol() je sputna na zatku programu. Tato
funkce pedpokld, e je ji aktuln polko nastaveno a jenom ho
vykresl, piem i zobraz okno programu.

\insf prvnipol

Funkce \dg [char] polvedle() je funkce, kter je zavolna v~okamiku,
kdy postava pechz z~jedn obrazovky do jin. Dostane postavu a
smr, kterm z~polka utekla, a vrt daj, zda se zmna polka
podaila.

Nespchem me tato funkce skonit akort v~ppad, e aktuln
polko nem poadovanho souseda. Jinak si piprav pslun
souadnice a pepne na pslun polko. Tak spust funkce
"odchfunc" a "prichfunc".

\insf polvedle

Funkc pro zmnu polka je funkce "kql_square". Prvn parametr, kter
tato funkce dostane, je postava. V~ppad, e tato postava nen
"NULL" ani lokln, chov se tato funkce podobn jako "posunpost"
(tedy zavol se funkce pi zmn barev), ale posouv mezi
polky. Druh parametr je polko, na kter bude pepnuto. Parametry
"px" a "py" jsou standardn clov souadnice postavy. Parametry "mx"
a "my" se po vynsoben kou i vkou nov mapy pitou
k~souadnicm "px" a "py". Tyto parametry zde mm proto, e nevm,
jak rozmry bude mt mapa na novm polku. Pokud bych napklad
chtl mt postavu na pedposlednm dku, pedm do parametru
"px = -2" a do parametru "mx = 1". 

Posledn parametr funkce "kql_square" je "vyhnout". Ten uruje, co m
program dlat, pokud je na poadovanch souadnicch ze. Kdy
"vyhnout == 0", tak se nic nedje a postava se tak objev na
zdi. Pokud "vyhnout == 1", tak funkce hled ve stejnm dku jako je
postava nejbli msto, kde ze nen, a kdy "vyhnout == 2", tak
funkce hled nejbli msto, kde ze nen ve sloupci.

\insf kql_square

Polko dle me obsahovat submapy a postavy. Ve struktue
"kq_policko" je toti seznam informac o~tom, e se m tam a tam
umstit submapa z~uritho souboru. Tento seznam informac je skryt ve
struktue \dg pol_submap, kter je v~"kq_policko" pod polokou
"psm". Struktura pol_submap tedy vypad takto:

\inst pol_submap

Poloky "x", "y" a "z" jsou souadnice submapy, "filename" je nzev
souboru, z~kterho je submapa tena, a "hide" je daj, zda m bt submapa
pi vytvoen schovan. Nen mon submap polka nastavit loklnost,
protoe je implicitn kad poloka polka lokln. Poloka "ulozit"
me obsahovat ukazatel, kam se dan submapa m nahrt. Pi odchodu
z~polka je pak do tchto ukazatel vloen "NULL". Funkce \dg [void]
pridej_psm() pid k~polku submapu.

\insf pridej_psm

Funkce \dl [void] pol_submapy() pak projde vechny submapy aktulnho
polka a vytvo tak submapy skutenho polka.

\insf pol_submapy

Podobn jako jsou submapy polka, existuj i postavy polka. To jsou
struktury \dg pol_postava, zalenny v~seznamu pod polokou "pp".

\inst pol_postava

Promnn "x", "y", "xz", "yz", "z", "smer" a "hide" se jednodue
zkopruj do skuten postavy. Poloky "sm_nazev", "sm_x", "sm_y"
a"sm_z" v~ppad, e "sm_nazev" nen "NULL", jsou pouity pro funkci
"post_submap". Poloky "a_x", "a_y", "a_nazev", "a_framu", "a_tim",
"a_jednopol" a "a_porad" jsou pedny funkci "nactianip", kter
vytvo animaci urenou pro postavu. To se samozejm stane jen
v~ppad, e v~poloce "a_nazev" nen "NULL". Funkce \dg [void]
pridej_pp() pid k~polku postavu. Poloka "ulozit" funguje stejn
jako v~ppad "pol_submap".

\insf pridej_pp

Funkce \dl [void] pol_postavy() projde postavy aktulnho polka a
vytvo podle nich skuten postavy.

\insf pol_postavy

Dal struktura, kterou k~polku ukldm, je \dg pol_widget v~poloce
"pw" struktury "kq_policko". Tato struktura ovem nen tak jednoduch
jako pedchoz dv. Nepidluje toti polku jen widgety, ale i
pixmapy a animovan widgety.

\inst pol_widget

Seznam tchto struktur funguje jako fronta a ne jen jako seznam, take
je teba, aby pi ukldn do polka byla znm posledn poloka. Tu
ukldm do promnn \dl [pol_widget *]pospw.

\ifirst {pol.c}{pospw}{}{++}

Funkce \dl [void] pw_alloc() pid do tto fronty nov prvek.

\insf pw_alloc

Poloka "typ" uruje, co se stane. Me nabvat t hodnot:

\ifirst {pol.c}{PW_PIX}{PW_ANIM}{++}

Pokud "typ == PW_PIX", m bt natena pixmapa ze stringu v~poloce
"u.pixmap". Funkce \dg [void] pw_pix() pid do fronty daj o~naten lokln
pixmapy.

\insf pw_pix

Pokud ve struktue "pol_widget" poloka "typ == PW_WID", pak bude vytvoen
widget se souadnicemi podle podpoloky "widget" v~poloce "u"
struktury "pol_widget". Pixmapa mu je automaticky pidlena
posledn. Widget je do fronty pidn funkc \dg [void] pw_wid().

\insf pw_wid

Funkce \dg [void] pw_xy() pid do fronty tak widget, ale bude mt
stejn rozdl Y-ov a Z-kov souadnice jako naposledy pidan widget.
Tento rozdl si uchovvm v~promnn \dl [float] rozdilz().

\ifirst {pol.c}{rozdilz}{}{++}

\insf pw_xy

Funkce \dg [void] pridej_pw() pid do fronty pol_widget jednu
pixmapu a jeden widget, co vlastn tvo jeden ucelen prvek.

\insf pridej_pw

Posledn mon "typ" struktury "pol_widget" je \dg PW_ANIM. Jakmile se
toto objev, jsou v~poloce "u.widget" animovanho widgetu. V~pt
poloce fronty pak je pouita poloka "u.anim", ve kter jsou
informace pro timer a poet polek animace. Nakonec jsou do poloky
"u.pokranim" ukldny postupn asy a pixmapy. Do kad takov poloky
se vejdou dva asy a dv pixmapy. Pixmapa nen ukldna jako pointer,
ale jako slo, kolikt pixmapa to je. slo 0 znamen "NULL", slem
1 je urena naposledy peten pixmapa, slem 2 pixmapa natena ped
touto pixmapou, ...

Funkce \dg [void] pw_anim() pid do fronty jeden animovan widget, tedy ve
to, o~em jsem psal v~pedchozm odstavci. M promnn poet parametr
a poet prvk animace je dn potem pol aniimace. Tyto parametry se
od parametru "prvpix" stdaj takto: slo pixmapy, as, slo
pixmapy, as, ..., slo pixmapy, as, $-1$. Seznam parametr se tedy
ukon, kdy je napsno $-1$. Dle funkce "pw_anim" pite jedniku
k~poloce "pocetanim" ve struktue "kq_policko".

\insf pw_anim

Pi vstupu na polko funkce \dl [void] pol_widgety() projde frontu
"pw" v~polku a provede ji. Na zatku je namallokovno pole
\dg [kq_anim *]animpole podle poloky animpole.

\ifirst {pol.h}{animpole}{}{++}
\insf pol_widgety

Tato funkce pro zskn submapy z sla pixmapy pouva funkci
\dl [kq_pixmap *]vylovpix().

\insf vylovpix

Funkce \dg [void] free_animpole() smae "animpole" pi odchodu
z~polka.
