Tento modul spojuje widgety a submapy do jedn struktury, kter se
jmenuje \dg kq_postava.

\inst kq_postava

Postavy jsou pomoc poloky "next" azeny do zsobnku zanajcm
postavou \dg [kq_postava *]prvpost.

\ifirst {post.c}{prvpost}{}{++}

Poloky "x" a "y" udvaj souadnice postavy na map "mapa". Poloky
"xx" a "yy" udvj rychlost postavy. Konkrtn vdy, kdy je na postavu
zavolna funkce "jdipost", pite k~poloce "x" poloku "xx" a
k~poloce "y" poloku "yy".

Dal poloka je "tim". Tato poloka me obsahovat libovoln timer,
ale obvykle obsahuje timer, kter opakovan vol funkci "jdipost" na
tuto postavu.

Dal tyi poloky jsou pravdivostn hodnoty. Poloka "zdi" zmamen,
e postava neme chodit pes \cite barvy[m:color], kter maj poloku "zed"
nastavenu na true. Poloka "barvy" znamen, e je pi posunut postavy
zavolna funkce "spustfb". Poloka "odraz" znamen, e kdy postava
neme jt tam, kam by mla. nezastav se, ale jde na opanou stranu.
Poloka "odejde" znamen, e me postava pejt na jinou
obrazovku. V~ppad, e je postava lokln, je tak zruena nebo
schovna. Jinak je zmnno aktuln polko. Poloka "odraz" je
implicitn nastavena na false. Ostatn poloky ("zdi", "barvy" a
"odejde") jsou implicitn nastaveny na true.

Postava me mt pointer na submapu v~poloce "submap". Poloky "sm_x"
a "sm_y" udvaj, kde je v~submap sted postavy. Nastavit submapu
postavy je mon funkc \dg [void] post_submap().

\insf post_submap

Kad postava m njak cl, tedy to, kam chce dojt. Implicitn to je
polko se souadnicemi 0,0. Tento cl me bt dn bu souadnicemi
mapy nebo postavou, kterou chce tato postava dohnat. Poloka
"autou_typ" uruje, co z~tchto monost to je. Me nabvat jednu
z~nsledujcch monost:

\dgn AUTOU_SOUR \dgn AUTOU_POST
\ifirst {post.h}{AUTOU_SOUR}{AUTOU_POST}{++}

Nsleduje samotn union obsahujc potebn informace.

Funkc \dg [void] setchytsour() nastavm souadnice cle.

\insf setchytsour

Funkc \dg [void] setchytpost() nastavm postavu, kterou chce postava
chytit.

\insf setchytpost

Funkce \dg [void] getchytsour() pak zsk souadnice cle.

\insf getchytsour

Dal polokou postavy je "chyt_vzdal", minimln vzdlenost pi kter
se spust funkce "chyt_func", kter je dal polokou
postavy. Implicitn "chyt_vzdal" je nula a implicitn funkce
"chyt_func" je "NULL". Funkce \dg [void] zkuschytit() otestuje, zda je
postava svmu cli dostaten blzko a ppadn spust "chyt_func".

\insf zkuschytit

Dal polokou je "auto_func", co je funkce pro automatick ovldn
postavy. Tato funkce se me spustit bu vdy, kdy se spust funkce
"jdipost" na tuto postavu, a nebo jednou za urit asov interval.
V~druhm ppad je v~poloce "auto_tim" timer, kter opakovan funkci
spout. e m bt "auto_func" sputena pi "jdipost", se pozn podle
toho, e "auto_tim" je "NULL".

Funkce \dg [void] autopost() piad postav jej "auto_func", ppadn
zalo timer s~prioritopu \dg [int] AUTOPRIOR. Dostane postavu, pak tu
funkci, potom as, po kterm se
m funkce poprv spustit a nakonec as, po kterm se spout
opakovan. V~ppad, e je posledn parametr nulov, nezakld vbec
timer a tedy ignoruje i pedposledn parametr. Nejastji jsou tto
funkci pedvny funkce z~modulu \vizmod[autopost].

\insf autopost

Dal polokou struktury "kq_postava" je funkce "free_func". Tato
funkce je zavolna tsn ped uvolnnm postavy z~pamti. Nen vak
mon, aby tato funkce onomu uvolnn zabrnila.

Poloky "animace", "smer", "animstav" a "animtim" uruj pixmapu,
kter bude pro postavu pouita a budou ble vysvtleny u~datovho
typu "kq_animpost".

Poloka "widget" je ukazatel na widget pipadajc postav. Tento
widget existuje od zatku postavy, ale m na zatku NULLovou
pixmapu.

Dal ti poloky "xz", "yz" a "z" uruj Z-kovou souadnici
postavy. Z~tchto daj a souadnic postavy se Z-kov souadnice
spot funkc \dg [float] spocti_z() takto:

\insf spocti_z

Pro zjednoduen ukldn poloek "xz", "yz" a "z" mm funkci
\dg [void] post_z().

\insf post_z

Dal poloky jsou "lokalni" a "hide", kter jsou s~podobnm elem i
v~dalch strukturch ("kq_widget", "kq_submap", v~"kq_timer" je msto
"hide" poloka "pause"). Tyto poloky se dd z~postavy do struktur,
kter obsahuje (akoliv nepouvm C++). Pro schovn a odschovn
postavy jsou funkce \dg [void] hidepost() a \dg [void]
unhidepost(). Postavy vak narozdl od ostatnch struktur nemaj pro
schovan postavy speciln seznam.

\ifirst {post.c}{hidepost (}{\count=2 ^^B\cbrace}{++}

Je teba si vak uvdomit, e poloka "lokalni" nen tak snadno
mniteln jako v~ostatnch strukturch. Zmnou tto poloky toti
nejsou zmnny poloky "lokalni" v~timerech, widgetu, a submap,
kterou tato postava obsahuje. Funkce, kter smae vechny lokln
postavy se tmito strukturami toti nezabv, protoe pedpokld, e
u tyto struktury vyeily funkce patc onm strukturm. Funkce,
kter smae lokln postavy se jmenuje \dg [void] deletelposts().

\insf deletelposts

Jeliko se snam etit s~grafickmi operacemi, nezmnm widget
postavy okamit po zmn postavy, ale pouze si oznam postavu jako
pozmnnou tm, e do jej poloky "zmena" dosadm true a navc zapu
true do promnn \dg [void] menpost. Tuto operaci udl funkce \dg [void]
zmenapost().

\ifirst {post.c}{menpost}{}{++}

\insf zmenapost

Na konci kadho framu je pak zavolna funkce \dg [void]
updateposts(), kter v~ppad, e "menpost" je true projde vechny
postavy a uprav widgety tch, kter maj poloku "zmena"
pravdivou. Zrove tuto poloku vynuluje a nakonec vynuluje i
promnnou "mengraf".

\insf updateposts

Funkce "vytvorpost" zalo novou postavu a vrt ukazatel na
ni. Pitom, pokud do parametru "tim" dostane vt slo ne nula,
zalo timer, kter kadch "tim" fram zavol funkci "jdipost" na
pslunou postavu. Parametr "tprior" uruje 

\insf vytvorpost

Funkce \dg [void] znicpost() smae postavu vetn vech struktur, kter
obsahuje. Tuto funkci je teba pouvat opatrn. Pokud toti je
zniena postava uvnit funkce, kter s~touto funkc manipuluje, nen
zarueno, e se program bude chovat korektn. Je tedy jistj
v~takovch ppadech vytvoit timer, kter se spust za nula fram a
danou postavu zni.

\insf znicpost

Funkce \dg [void] deleteAposts() uvoln z~pamti vechny postavy.

\insf deleteAposts

Funkce \dg [void] posunpost() zmn souadnice postavy. To vak
provede pouze v~ppad, e zadan souadnice jsou uvnit mapy a
postavika na n me vejt (nen to ze nebo postava me na
zdi. Potom tato funkce spust funkce barev, tedy "spustfb". Pokud se
posun poda, vrt true, pokud ne, vrt false.

\insf posunpost

Funkce \dg [void] jdipost() je opakovan spoutna timerem, v~ppad, e pi
vytvoen postavy byl funkci "vytvorpost" pedn kladn parametr
"tim". Funkce "jdipost" nejprve spust funkci pro automatick pohyb,
potom posune postavu o~"xx" a "yy" a nakonec posune animaci
postavy. Krom toho tato funkce nastav podle "xx" a"yy" poloku
"smer". Pi potn poloky "smer" m poloka "xx" vt prioritu ne
"yy".

Pokud by postava mla odejt z~mapy, tak v~ppad,
e postava nen lokln, zmn polko (obrazovku). Jinak je postava
schovna ("lokalni < 0") nebo zniena ("lokalni > 0").

\insf jdipost

Postav se nepiazuje jen jedna pixmapa, ale souhrn pixmap, kter
maj bt pouity. Onen souhrn je struktura \dg kq_animpost, kter se
ulo do poloky "animace" v~postav.

\inst kq_animpost

Poloky "x" a "y" uruj souadnice v~pixmap, kde se nalz
postava. Po zjitn souadnic postavy se tedy jet odetou tyto
souadnice a tam se teprve umst onen widget.

V~poloce "pix.pole" se nalz pole ukazatel na pixmapu. Pokud by
vak toto pole mlo mt jen jeden prvek, je msto zakldn pole
rovnou uloena pixmapa do "pix.map".

Poet prvk pole uruje poloka "framu" spolu s~polokou
"jednopol". Pokud je "jednopol" true, udv poloka "framu" rovnou
poet prvk pole a pi posouvn postavy se tyto prvky pravideln
stdaj:

$$"0, 1, 2, ..., framu-1, 0, 1, ..."$$

Kdy je "jednopol" zporn, nestdaj se podle asu, ale podle
desetinsobku Z-kov souadnice postavy. Kdy je Z-kov souadnice
nulov, pouije se "pix.pole[0]", kdy to je $0.1$, tak se pouije
"pix.pole[1]", ... a kdy je Z-kov souadnice rovn "framu/10",
pouije se opt "pix.pole[0]".

Pokud vak je "jednopol" false, je prvk pole tyikrt vc, protoe
m postava pro kad smr jin pixmapy. V~poloce "smer" me bt
slo od nuly do t, co je bu "VLEVO", "VPRAVO", "NAHORU" nebo
"DOLU" V~takovm ppad se pixmapy stdaj takto:

$$"framu*smer, framu*smer+1, framu*smer+2, ..., framu*smer+(framu-1),
framu*smer, ..."$$

Poloka "porad" v~struktue "kq_animpost" uruje, zda m bt poloka
animovna, i kdy stoj. Poloka "tim" uruje, jak rychle m bt
animace postavy provdna. Pi piazen animace postav, je do
poloky "animtim" v~postav uloen timer s~prioritou \dg [int]
ANIMPRIOR, kter posune animaci, tedy
spust funkci "anip_step". Pokud je poloka "tim" nulov, je posunuta
animace pi kadm zavoln funkce "jdipost".

Aktuln pixmapa, kter m bt pouita, je urena polokou
"animstav". Tato poloka je slo mezi nulou a "framu-1". Aktuln
smr tedy tuto poloku neovlivuje.

Animaci postavy posune funkce \dg [void] anip_step(), kter se ped
ukazatel na danou postavu.

\insf anip_step

Poloka "lokalni" ve struktue "kq_animpost" udv, e bude tato
struktura smazna a pomoc poloky "next" jsou vechny animace postav
zaazeny do zsobnku, kter zan promnou "prvanip".

\ifirst {post.c}{prvanip}{}{++}

Funkce \dg [kq_animpost *]nactianip() zalo novou strukturu
"kq_animpost" a nate do nich ze soubor obrzky podle nzvu, kter
dostane. Nakonec vrt ukazatel na nov zaloenou strukturu. Pokud m
nast jen jednu pixmapu, pete si jednodue dan nzev s~pponou
{\tt xpm} v~adresi s~animacemi postav. Jinak pedpokld, e nzev, kter
funkce dostala, je nzev adrese, ve kterm jsou pixmapy
uloeny. Pokud je "jednopol" true, tak zde vyaduje soubory: "anim0.xpm",
"anim1.xpm", "anim2.xpm", ... Jinak zde jsou soubory: "up0.xpm",
"up1.xpm", ..., "left0.xpm", "left1.xpm", ..., "right0.xpm", "right1.xpm", ...,
"down0.xpm", "down1.xpm", ... V~ppad, e "framu == 0", nejsou
pouity soubory "up0.xpm", "left0.xpm", ..., ale jenom: "up.xpm", "down.xpm",
"left.xpm", "right.xpm".

\insf nactianip

Funkce \dg [void] zmenanip() nastav postav jej animaci.

\insf zmenanip

Funkce \dg [void] freeanip() uvoln animaci postavy z~pamti a souasn i
pixmapy, kter se v~n nalzaj. Tuto funkci nen dobr pout
bezprostedn po odebrn dan animace urit postav, protoe pixmapa
zstv pidlena widgetu do konce jednoho framu.

\insf freeanip

Funkce \dg [void] deletelanips() smae vechny "kq_animpost", kter
maj poloku "lokalni" nastavenou na true.

\insf deletelanips

Funkce \dg [void] deleteAanips() smae pln vechny "kq_animpost".

\insf deleteAanips

Animace postav ("kq_animpost") se daj zafixovat podobn jako pixmapy
("kq_pixmap" pomoc "fix_pix"). Funkce \dg [void] fix_anips() pevede
vechny dosud naten animace do seznamu \dg [kq_animpost
*]fixed_anips, m zru monost je mazat a tak tak nejsou
ukldny do souboru s~uloenou pozic. Pitom ulo poet animac, kter takto
zafixovala do promnn \dg [int]
pocet_fixanips. Nakonec tato funkce zavol "fix_pix", m zafixuje
pixmapy. Tato funkce by tedy nemla bt spoutna vcensobn ani by
nemla bt sputna v~ppad, e je jindy sputna funkce "fix_pix".

\ifirst {post.c}{fixed_anips}{^^B\cbrace}{++}
