V~tomto modulu jsou funkce, kter je mon pout pro automatick
pohyb postavy. Funkce \dg [void] randomsmer() ulo do svch parametr
nhodn, ikm nebo rovn smr.

\insf randomsmer

Pravda, tato funkce se jet jako funkce pro automatick pohyb postavy
pout ned, protoe m jakoto parametr dv cel sla a ne
postavu. Funkce \dg [void] auto_random() tedy m parametr postavu a
k~uren smru pouije "randomsmer".

\insf auto_random

Funkce \dg [void] primosmer() ulo do promnnch "xx" a "yy" smr
podle parametr "x" a "y". Parametry "x" a "y" jsou relativn
souadnice cle, kam se chce postava dostat, podle postavy. Funkce se
sna postavu co nejpesnji nasmrovat na cl. ikm smr je pouit
v~okamiku, kdy nen dn souadnice dvakrt vt ne druh.

\insf primosmer

Podobn jako u~funkce "randomsmer" i zde je funkce, kter aplikuje
funkci "primosmer" na postavu. Tato funkce se jmenuje "auto_primo".

\insf auto_primo

Tyto algoritmy jet nejsou ideln, protoe by bylo nkdy douc,
aby postava pi sledovn svho cle obchzela zdi. Takov algoritmus
nazvu chytrm. Budu pedpokldat, e bude chytr algoritmus sputn pi
kadm posunut postavy, aby mohl svou postavu zcela ovldat. Pokad
by vak ml znovu vypotat smr bez toho, aby si udroval z~minula
njak vpoty. To proto, e bych zaprv tyto vpoty musel ukldat
pi ukldn pozice, a za druh proto, e cl me bt pohybliv. To
je na chytr algoritmus docela velk poadavek, take po nm nebudu
dat, aby nael nejkrat cestu. Pesto by vak za pedpokladu, e se
cl nebude hbat, ml k~cli nkdy dorazit, tedy neml by se
zacyklit.

K~tomu si jet na map zavedu men vzdlenost pomoc max
metriky. Vzdlenost mezi dvma body zmm funkc
\dg [int] vzdalenost(). Tato funkce nejprve dostane souadnice
jednoho bodu, pak druhho a vrt jejich vzdlenost.

\insf vzdalenost

Funkce \dg [void] post_vzdal() zm vzdlenost mezi dvmi postavami.

\insf post_vzdal

Nyn se vrtm k~dumn nad chytrm algoritmem. V~ppad, e me
postava jt pmo za clem, mohla by jt pmo za clem. Co vak
dlat, kdy j pek ze? V~takovm ppad chytr algoritmus ze
obejde tak, aby byl co nejble svmu cli. Ze se vak d vtinou
obejt dvma smry, take si chytr algoritmus jet mus vybrat tu
krat cestu.

Problm nyn nastane v~ppad, e v~okamiku, kdy obchz ze, ho
napadne, e by se mohl zdi pustit a jt pmm smrem, akoliv nen
jet nejble svmu cli. Tento problm vyem tak, e mu zabrnm
se odlepit od zdi dokud nen nejble svmu cli u~zdi. Tm bych ml
chytr algoritmus popsan, take pistoupm k~nzorn ukzce. Postava
zan na fialovm tvereku a sna se dostat do zelenho. ern
tvereky jsou zdi a svtle modr ra je cesta, kterou pjde.

\ifig 0.5 cesta

Nejprve jde chytr algoritmus pmo za svm clem. Potom naraz na ze
a obchz ji, dokud nen jeho vzdlenost od cle nejmen (v~naem
pklad~11). Zde je vyuita jeho lepivost ke zdi. Kdyby se k~n
nelepil, tak by se zacyklil
uvnit. Pak se od zdi odlep a jde opt pmo za svm clem. Pak se
ovem omylem nalep na dal ze, kter m ve svm mst nejblim
cli od cle vzdlenost 2, zatmco v~mst, kde se na n nalepil m od
cle vzdlenost 6.

Algoritmus tedy obchz druhou ze. Nedojde ovem a k~mstu,
kde m vzdlenost od cle 2, protoe se tsn ped tm nalep na ze,
kter m v~nejblim mst od cle vzdlenost 0. Tuto ze pak obchz
tak dlouho, dokud se neocitne v~cli. Svoji ze algoritmus neopust
ani v~okamiku, kdy u je jeho vzdlenost od cle 1.

Pro implementaci tohoto algoritmu jsem si jet definoval funkce
\dl uvnitrmapy(), kter vrt true v~ppad, e zadan souadnice
nejsou mimo mapu, a funkci \dl jezed(), kter vrt true v~ppad, e
na zadanch souadnicch je ze. Tato funkce vrac true i v~ppad,
e postava m poloku "zdi" nastavenou na "false", take chytr
algoritmus obchz zdi i kdyby nemusel.

\ifirst {autopost.c}{uvnitrmapy}{jezed}{++}

Funkce \dl [char] obejdized() obejde urit blok zd a najde nejlep
cestu, kudy jt k~cli. Parametry "x" a "y" udvaj souadnice, ze
kterch vyraz. Parametry "xx" a "yy" udvaj, kterm smrem od
souadnic "x,y" je ze, kterou m funkce obejt. Prv jedna
z~promnnch "xx" a "yy" je tedy nula. Promnn "cilx" a "cily" udvaj
souadnice cle, ke ktermu mm bt co nejbl.

Do parametru "vzdal" ulo nejmen vzdlenost, na kterou se mu podl
zdi podailo piblit a do parametru "delka" ulo ulou vzdlenost
k~nejblimu mstu s~touto vzdlenost. Funkce obchz ze po smru
hodinovch ruiek a skon v~okamiku, kdy se opt dostane na stejn
msto. V~ppad, e se vyplat jt po smru, vrt jedniku a do
parametr "nejxx" a "nejyy" zkopruje "xx" a "yy". Pokud se ovem
vyplat jt proti smru, ulo do "nejxx" a "nejyy" hodnoty, kterm
smrem byla ze, kdy skonil. V~ppad, e k~dosaen minimln
vzdlenosti nen vbec teba jt podl zdi, vrt funkce nulu.

\insf obejdized

Konen funkce \dg [void] auto_clever() nastav postav smr podle
chytrho algoritmu. Nejdv prohldne sousedn tyi polka a jestli
nezjist, e by ml obchzet ze, jde pmo. Pokud tmto pmm smrem
opt naraz na ze, obejde jet tuto ze.

\insf auto_clever
