Pedmt, tedy struktura \dg kq_predmet, spojuje postavy, slova a
polka. Tato struktura vypad nsledovn:

\inst kq_predmet

Pedmt m ti monosti, kde me bt. Bu me bt v~inventi, na
njakm polku (scn) nebo tak nemus bt nikde. V~ppad, e je
pedmt v~inventi, tak poloka "inv" je nastavena na true.
V~modulech \cite save a load[m:save] pak poloku "inv" pouiju jako daj
o~poad v~inventi. Toto poad je toti dleit pi zobrazen
invente. Pokud "inv" je false, tak v~poloce "pol" je daj o~tom,
na kterm polku se pedmt vyskytuje. O~umstn na polku pak
rozhoduj poloky "pix_x", "pix_y", "pix_z", "sm_x", "sm_y",
"sm_z". Pedmt, kter nen nikde, pak m v~poloce "pol" uloeno
"NULL".

Vechny vytvoen pedmty jsou azeny do seznamu pomoc poloky
"next", kter zan promnnou \dg [kq_predmet *]prvpredmet. Krom
toho jsou
souasn pedmty azeny do dalch seznam pomoc poloky
"polnext". Pedmty nachzejc se v~inventi jsou v~seznamu
zanajcm promnnou \dg [kq_predmet *]inventar a pedmty, kter
jsou na uritm polku, jsou v~seznamu zanajcm polokou
"predmety" pslunho polka.

\ifirst {predmet.c}{inventar}{prvpredmet}{++}

Do sprvnho seznamu pospojovanho polokou "polnext" zaad pedmt
funkce \dl [void] zaradpredmet().

\insf zaradpredmet

Funkce \dl [void] vyradpredmet() pak pedmt z~takovho seznamu vyad.

\insf vyradpredmet

Ve struktue "kq_predmet" dle me bt v~poloce "slovo" uloeno
urit slovo ("kq_word"). Toto slovo m "typ" nastaven na "OBJWORD" a
v~poloce "informace" je ukazatel zptky na pedmt. Dle je tomuto
slovu zven kontext o~jedniku v~ppad, e je pedmt
v~inventi nebo na prv aktivnm polku. Po odebrn z~invente
nebo zmn aktivnho polka kontext opt poklesne.

Zsadn polokou pedmtu je jeho "nazev". Tento string nesm bt
"NULL" a je pouvn jako:

\begitems
\item 1) nzev submapy, kter je pouita pro pedmt.
\item 2) nzev jednolen animace postavy.
\item 3) nzev pixmapy, kter bude zobrazena pi prohlen invente.
\enditems

Funkce \dg [void] zmenprnazev() zmn nzev pedmtu. Pokud je vak
pedmt vyobrazen na aktulnm polku, nezmn se, dokud se na toto
polko nevejde znovu. Pro okamitou zmnu pedmtu je mon ho
pezobrazit funkc "predmetpol".

\insf zmenprnazev

Tato funkce navc zmn poloku "stav". Tato poloka struktury
"kq_predmet" je pi vytvoen pedmtu false a ukazuje prv, zda byl
zmnn jeho nzev. Navc "stav" ovlivuje pouit output v~inventi.

Funkce \dg [void] vytvorpredmet() zalo nov pedmt, kter nen ani
v~inventi ani na polku. Do parametru "nazev" dostane nzev
pedmtu a do parametru "slovo" daj, zda m tato funkce do pedmtu
pidat nov slovo.

\insf vytvorpredmet

Pro manipulaci s~pedmty dle existuj ti funkce. Funkce
\dg [void] predmetinv() d pedmt na zatek invente.

\insf predmetinv

Funkce \dg [void] predmetpol() d pedmt na uren polko. Tato
funkce dle dostane souadnice, kde m bt umstna pixmapa
v~parametrech "pix_x", "pix_y" a "pix_z", a souadnice, kde m bt
umstna submapa v~parametrech "sm_x", "sm_y", "sm_z". Kad pedmt
tedy mus mt pixmapu i submapu. Souadnice
"pix_x" a "pix_y" nejsou souadnicemi od levho hornho rohu
obrzku, ale od levho hornho rohu hlavn mapy. Skuten souadnice
tedy jsou "map_xb+pix_x", "map_yb+pix_y".

\insf predmetpol

Funkce \dg [void] predmetnull() vrt pedmt do potenho stavu,
kde pedmt nen ani v~inventi ani na dnm polku.

\insf predmetnull

V~ppad, e se pedmt objev na aktulnm polku, je do jeho
poloky "post" vytvoena lokln postava bez timeru, kter se piad
jednoprvkov animace podle poloek "nazev", "pix_x" a "pix_y", Z-kov
souadnice podle poloky "pix_z" a submapa podle poloek "nazev",
"sm_x", "sm_y" a "sm_z". Navc je teba pist kontext ke slovu
pedmtu. Tohle vechno provede funkce \dl [void] zobrazpredmet().

\insf zobrazpredmet

Kdy se zaktivn urit polko, je douc, aby na nm byly takto
zaktivnny vechny jeho pedmty. Pi vykreslovn polka je proto
zavol funkce \dg [void] zobrazpredmety().

\insf zobrazpredmety

Podobn v~ppad, e pedmt zmiz z~aktulnho polka, je teba
poloku "post" z~pedmtu opt vymazat a kontext zptky odest. To
dl funkce \dl [void] zmizpredmet.

\insf zmizpredmet

Funkce \dg [void] zmizpredmety() je zavolna pi odchodu
z~polka. Tato funkce vak nepouv funkci "zmizpredmet", protoe
budou postavy pedmt automaticky znieny dky sv loklnosti. Take 
funkce "zmizpredmety" jen do poloky "post" dosadi "NULL" a sni
kontext.

\insf zmizpredmety

Nsledujc dv funkce jenom zobraz vyskakovac okno s~hlkou
tkajc se pedmt. Funkce \dg [void] uzmaspredmet vysko s~hlkou
s~labelkem "_uz mas", kde je "#" nahrazen nzvem slova danho
pedmtu.

\insf uzmaspredmet

Funkce \dg [void] sebralspredmet() vysko s~hlkou s~labelkem
"_bere" a slovem danho pedmtu.

\insf sebralspredmet

Funkce \dg [char] seberpredmet() dostane pedmt, kter m
sebrat. Tato funkce se pokus sebrat pedmt z~polka do
invente. V~ppad, e pedmt nebyl na aktulnm polku, vrt
tato funkce $-1$. Pokud se mu povede pedmt sebrat, vrt 1. Nulu
vrt v~ppad, e souadnice, kter funkce dostala, jsou pli
daleko od pedmtu. V~takovm ppad navc vysko s~hlkou pod
labelkem "_too far". e jsou souadnice pli daleko, program pozn
podle toho, e v~submap psluc pedmtu, tyto souadnice nejsou
v~barv \dg [kq_color *]dosahpredmet. Pokud "dosahpredmet == NULL",
neme situace, e bych byl pli daleko, vbec nastat.

\ifirst {predmet.c}{dosahpredmet}{}{++}

\insf seberpredmet

Funkce \dg [char] seberslovo() zavol funkci "seberpredmet"
s~parametrem zskanho ze slova pedmtu, kter dostane. Souadnice
ur podle "ovlpost".

\insf seberslovo

Funkce \dg [void] ukazinv() zobraz invent jako vbr. Kdy na
njak poloce hr zmkne enter, smae vbr a zobraz  pslunou
poloku invente. Potom opt zobraz invent ve stejnm mst jako
ho ukonil. Nzev poloky invente si bere z~outputu podle slova
pedmtu. V~ppad, e slovo m "stav" false, pouije labelk "_inv" a
v~ppad, e slovo m "stav" true, pouije labelk "__inv". Nadpis
invente si vythne z~labelku "_inventar".

\insf ukazinv

Funkce \dg [void] koukniinv() zobraz jeden pedmt. Nate si pixmapu
podle nzvu pedmtu, kterou zobraz v~horn sti okna, a ve spodn
sti okna zobraz text o~tom pedmtu. st vky okna, do kter se
zobraz pixmapa, je \dg [float] UINVPOMER. Text se pak zobraz s~vkou
"1-UINVPOMER" a kou \dg [float] UINVSIRKA. Jako labelk pouije "_inv_look"
v~ppad, e "stav" pedmtu je false, nebo "__inv_look" v~ppad,
e "stav" pedmtu je true. Dle pi vyhledn vhodnho outputu
pouije "slovo" pedmtu. Pro zobrazen pixmapy funkce nevyuv modul
\vizmod[widget], ale zobraz ji pmo jako okno, take nemus pesn pasovat na
pixelovou mku na pozad.

\insf koukniinv

Funkce \dg [void] deleteApredmets() smae vechny pedmty. Pouv se
pi natn pozice nebo pi restartu.

\insf deleteApredmets
