Zkladn pedstava timeru je jaksi budk, kter po pedem urenm ase
zazvon, ili spust uritou funkci. Obvykle (jinde ne v~tomto programu)
se timeru zadv poet sekund a milisekund, jakoto as, za kter se
m spustit. Tento pstup vak nen pesn, jeliko i vpoet trv
njakou dobu a navc chci hru nkdy zpomalovat nebo zrychlovat. Tady
se tedy timeru piad poet fram.

Timer se deklaruje jako ukazatel na datov typ \dg kq_timer. Definice
tohoto datovho typu vypad nsledovn:

\ins h kq_timer

S~tmto datovm typem se d manipulovat pomoc funkc:

\ins h prototypy

Prvn dv poloky struktury uruj, co se m stt pi \uv{zazvonn} timeru.
Spust se funkce "funkce" s~danm parametrem podle "kq_pin", \vizmod[pin].

Pot, co timer \uv{zazvon}, se s~nm mohou stt dv vci. Bu zmiz
(smae se) a u se s~nm ned nic dlat nebo se pust znova. V~poloce
"opakovani" je poet \uv{zazvonn}, kter timeru jet zbvaj. Je-li
"opakovani" zporn nebo nulov, bude se timer opakovat pod. Poloka "cas"
udv, na jak as se m timer pi opakovn zptky nastavit.

Poloky "opakovani" i "cas" se daj bez problm mnit. Mnte-li vak
timer, co je prv sputn, je dobr vdt, co pesn dl funkce
"dotimers()".

Funkce "dotimers" spust timery, co jsou prv na ad. Ukazatel na
prv sputn timer pitom ulo do globln promnn \dg [kq_timer] aktutimer.

\ins c aktutimer

Nen-li sputn dn timer, je "aktutimer" roven "NULL". Rovn vak
me "aktutimer" nabvat hodnoty "NULL" v~ppad, e byl smazn (sm sebou).

Kad timer, kter nen "aktutimer", je bu v~seznamu putnch nebo
zapausovanch timer. Ke kadmu putnmu timeru, kter nen "aktutimer", se
d dostat pes poloky next z~timeru "prvtimer", k~zapausovanmu timeru
se d dostat z~timeru "pausedtimers".

\ins c seznamy

Zapausovan timery jsou jednodue (zsobnkov) azeny za sebe a v~poloce
"zbyva" zapausovanho timeru je zbvajc as. Stejn tak je zbvajc as
timeru "aktutimer" v~"aktutimer->zbyva".

Seznam putnch timer je setzen od toho, co se spust nejdve, po ten, co
se spust nejpozdji. Zvis to tedy na zbvajcm ase a priorit. V~poloce
"zbyva" putnho timeru je rozdl zbvajcho asu toho a pedchozho timeru.
Ke spoten zbvajcho asu sputnho timeru je teba sest poloky "zbyva"
timer od timeru "prvtimer" po dan timer (vetn), co dl funkce
\dg [int] zjistitimer().

\ins c zjistitimer

Vhodou takovho
uspodn ale je, e pro posunut ruiky vech timer sta odest
jedniku od "zbyva" v~prvtimeru, to se dje ve funkci "loop". Pklad
situace timer je na obrzku:

\ifig .8 timer

Pro manipulaci s~timery zde jsou statick funkce \dl [void] zaradtimer() a
\dl [void] vyradtimer().
Tyto funkce podle poloky "pause" zaad/vyad timer do/z pslunho seznamu.
O~timeru "aktutimer" tyto funkce nepeml.

\ins c zaradvyrad

Funkce \dg [void] dotimers() provede s~timerem, kter \uv{zazvonil} toto:

\begitems
\item1) Ulo timer do globlnho timeru "aktutimer", nastav do zbvajcho
	asu hodnotu z~poloky "cas" a nen-li poloka "opakovani" zporn, zmen
	ji o~jedniku.
\item2) Spust patinou funkci
\item3) Pokud je poloka "opakovani" nulov, smae timer, jinak ho vrt mezi
	ostatn timery.
\enditems

\ins c dotimers

Funkce "zjistitimer" spot poet fram, za kter se timer pust.
K~tomu vyuije poloku "zbyva" v~"kq_timer".

Jeliko se timerm nedv reln, ale celoseln as, me se snadno stt,
e v~jednom \uv{zazvon} vce timer najednou. V~takovm ppad se funkce
timer pout postupn od timeru s~nejvy hodnotou poloky "priorita"
po timer s~nejni hodnotou poloky "priorita".

Jak zbvajc as, tak prioritu je teba mnit funkc \dg [void] zmentimer(). Tato
funkce zbvajc as nahrad hodnotou z~parametru "cas", ale nepepe
poloku "cas". Krom toho jet pepe poloku "priorita".

\ins c zmentimer

Dle je mon timer zapausovat funkc \dg [void] pausetimer() a odpausovat funkc
\dg [void] unpausetimer(). Informace, jestli je timer zapausovn, je v~poloce
"pause" (0 = odpausovn, 1 = zapausovn). Zapausovan timer, ktermu
nezbv dn frame, se spust a po odpausovn.
Funkce "pausetimer" prci se seznamy e samostatn. Pi vyazen toti mus
spotat zbvajc as a zaazen k~zapausovanm timerm je pli snadn na
to, aby na to byla volna funkce.

\ins c pause

Posledn poloka timeru je "lokalni". Podle n se d funkce
\dg [void] deleteltimers(), kter je sputna pi pechodu na jin polko.

Poloka "lokalni" me nabvat t hodnot:

\begitems
\item* Nula znamen, e je timer globln, ili funkce "deleteltimers" s~nm nic
       neprovede.
\item* Zporn slo znamen, e ten timer funkce "deleteltimers" zapausuje, je-li
       ji zapausovn, nic se s~nm nedje.
\item* Kladn slo znamen, e ten timer funkce "deleteltimers" smae.
\enditems

Poloku "lokalni" je mon zcela bez problm mnit.

\ins c deleteltimers

Pro natn pozice je teba smazat vechny timery. To dl funkce
\dg [void] deleteAtimers().

\ins c deleteAtimers

Funkce \dg [kq_timer] vytvortimer() zalo nov timer a do kad poloky struktury piad
pslun parametr. Zbvajc as zan na hodnot "cas".

\ins c vytvortimer

Funkce \dg [void] znictimer() smae timer.

\ins c znictimer

Jet jsou dostupn dv funkce jakoto ladc tisky. Funkce
\dg [void] vypistimer() vype dostupn informace o~danm timeru,
funkce \dg [void] vypistimery() pomoc funkce "vypistimer" vype
vechny timery.
